# -*- coding: utf-8 -*-
from hwm.plugin.base import PluginManager, BaseColectorPlugin
from argparse import ArgumentParser
from threading import Thread

import signal
import os

def main():
    args = ArgumentParser()
    args.add_argument(
        '--colector',
        dest = 'colector',
        help = u'Specify the colector plugin used for colect data.'
    )
    args.add_argument(
        '--extract',
        dest = 'extract',
        help = u'Specify the colector plugin used for colect data.'
    )
    args.add_argument(
        '--list-colector',
        dest = 'list_colector',
        help = u'Specify the colector plugin used for colect data.',
        action = 'store_true'
    )
    args.add_argument(
        'args',
        nargs = '+'
    )

    process(args.parse_args())

def process(namespace):
    if namespace.list_colector is True:
        print 'list-colectores'
    else:
        if namespace.colector is not None or namespace.extract is not None:
            args = []

            for arg in namespace.args:
                args.extend(arg.split(' '))

            pm = PluginManager(BaseColectorPlugin)
            try:
                Colector = pm.get(namespace.colector if namespace.colector else namespace.extract)
            except pm.PluginNotFound, e:
                print unicode(e)
            else:
                ap = ArgumentParser()
                for opt in Colector.description().get('options'):
                    ap.add_argument(opt[0], **opt[1])

                print 'Pid: %d' % os.getpid()
                
                c = Colector(ap.parse_args(args))
                f = lambda x: x.get_data_sequence(True)
                c.colect() if namespace.colector is not None else f(c)


__name__ == '__main__' and main()