# -*- coding: utf-8 -*-
from hwm.plugin.base import PluginManager, BaseGraphicPlugin
from argparse import ArgumentParser

import signal
import os

def main():
    args = ArgumentParser()
    args.add_argument(
        '--draw',
        dest = 'colector',
        help = u'Specify the colector plugin used for draw data.'
    )
    args.add_argument(
        '--list-graph',
        dest = 'list_graph',
        help = u'Specify the colector plugin used for draw data.',
        action = 'store_true'
    )
    args.add_argument(
        'args',
        nargs = '+'
    )

    process(args.parse_args())

def process(namespace):
    if namespace.list_graph is True:
        print 'list-colectores'
    else:
        if namespace.colector is not None or namespace.extract is not None:
            args = []

            for arg in namespace.args:
                args.extend(arg.split(' '))

            pm = PluginManager(BaseGraphicPlugin)
            try:
                Colector = pm.get(namespace.colector if namespace.colector else namespace.extract)
            except pm.PluginNotFound, e:
                print unicode(e)
            else:
                ap = ArgumentParser()
                for opt in Colector.description().get('options'):
                    ap.add_argument(opt[0], **opt[1])

                print 'Pid: %d' % os.getpid()
                
                c = Colector(ap.parse_args(args))
                c.draw()


__name__ == '__main__' and main()